//! @file
//!
//! This source file was generated from CellML by chaste_codegen version 0.1.0
//!
//! Model: zhang_SAN_model_2000_all
//!
//! Processed by chaste_codegen: https://github.com/ModellingWebLab/chaste-codegen
//!     (translator: chaste_codegen, model type: normal)
//! on (date omitted as unimportant)
//!
//! <autogenerated>

#include "zhang_SAN_model_2000_all.hpp"
#include <cmath>
#include <cassert>
#include <memory>
#include "Exception.hpp"
#include "OdeSystemInformation.hpp"
#include "RegularStimulus.hpp"
#include "HeartConfig.hpp"
#include "IsNan.hpp"
#include "MathsCustomFunctions.hpp"


    Cellzhang_SAN_model_2000_allFromCellMLRushLarsen::Cellzhang_SAN_model_2000_allFromCellMLRushLarsen(boost::shared_ptr<AbstractIvpOdeSolver> /* unused; should be empty */, boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus)
        : AbstractRushLarsenCardiacCell(
                15,
                0,
                pIntracellularStimulus)
    {
        // Time units: millisecond
        //
        this->mpSystemInfo = OdeSystemInformation<Cellzhang_SAN_model_2000_allFromCellMLRushLarsen>::Instance();
        Init();
        
    }

    Cellzhang_SAN_model_2000_allFromCellMLRushLarsen::~Cellzhang_SAN_model_2000_allFromCellMLRushLarsen()
    {
    }
    
    double Cellzhang_SAN_model_2000_allFromCellMLRushLarsen::GetIIonic(const std::vector<double>* pStateVariables)
    {
        // For state variable interpolation (SVI) we read in interpolated state variables,
        // otherwise for ionic current interpolation (ICI) we use the state variables of this model (node).
        if (!pStateVariables) pStateVariables = &rGetStateVariables();
        const std::vector<double>& rY = *pStateVariables;
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : rY[0]);
        // Units: millivolt; Initial value: -39.013558536
        double var_chaste_interface__sodium_current_m_gate__m = rY[1];
        // Units: dimensionless; Initial value: 0.092361701692
        double var_chaste_interface__sodium_current_h_gate__h1 = rY[2];
        // Units: dimensionless; Initial value: 0.015905380261
        double var_chaste_interface__sodium_current_h_gate__h2 = rY[3];
        // Units: dimensionless; Initial value: 0.01445216109
        double var_chaste_interface__L_type_Ca_channel_d_gate__d_L = rY[4];
        // Units: dimensionless; Initial value: 0.04804900895
        double var_chaste_interface__L_type_Ca_channel_f_gate__f_L = rY[5];
        // Units: dimensionless; Initial value: 0.48779845203
        double var_chaste_interface__T_type_Ca_channel_d_gate__d_T = rY[6];
        // Units: dimensionless; Initial value: 0.42074047435
        double var_chaste_interface__T_type_Ca_channel_f_gate__f_T = rY[7];
        // Units: dimensionless; Initial value: 0.038968420558
        double var_chaste_interface__four_AP_sensitive_currents_q_gate__q = rY[8];
        // Units: dimensionless; Initial value: 0.29760539675
        double var_chaste_interface__four_AP_sensitive_currents_r_gate__r = rY[9];
        // Units: dimensionless; Initial value: 0.064402950262
        double var_chaste_interface__rapid_delayed_rectifying_potassium_current_P_af_gate__P_af = rY[10];
        // Units: dimensionless; Initial value: 0.13034201158
        double var_chaste_interface__rapid_delayed_rectifying_potassium_current_P_as_gate__P_as = rY[11];
        // Units: dimensionless; Initial value: 0.46960956028
        double var_chaste_interface__rapid_delayed_rectifying_potassium_current_P_i_gate__P_i = rY[12];
        // Units: dimensionless; Initial value: 0.87993375273
        double var_chaste_interface__slow_delayed_rectifying_potassium_current_xs_gate__xs = rY[13];
        // Units: dimensionless; Initial value: 0.082293827208
        double var_chaste_interface__hyperpolarisation_activated_current_y_gate__y = rY[14];
        // Units: dimensionless; Initial value: 0.03889291759
        
        const double var_L_type_Ca_channel__E_Ca_L = 46.399999999999999; // millivolt
        const double var_L_type_Ca_channel__g_Ca_L_Centre_0DCapable = 0.0057938; // microS
        const double var_L_type_Ca_channel__g_Ca_L_Centre_1DCapable = 0.0082000000000000007; // microS
        const double var_L_type_Ca_channel__g_Ca_L_Centre_Published = 0.0057999999999999996; // microS
        const double var_L_type_Ca_channel__g_Ca_L_Periphery_0DCapable = 0.065886479999999997; // microS
        const double var_L_type_Ca_channel__g_Ca_L_Periphery_1DCapable = 0.0659; // microS
        const double var_L_type_Ca_channel__g_Ca_L_Periphery_Published = 0.0659; // microS
        const double var_T_type_Ca_channel__E_Ca_T = 45.0; // millivolt
        const double var_T_type_Ca_channel__g_Ca_T_Centre_0DCapable = 0.0042780600000000002; // microS
        const double var_T_type_Ca_channel__g_Ca_T_Centre_1DCapable = 0.0020999999999999999; // microS
        const double var_T_type_Ca_channel__g_Ca_T_Centre_Published = 0.0043; // microS
        const double var_T_type_Ca_channel__g_Ca_T_Periphery_0DCapable = 0.0138823; // microS
        const double var_T_type_Ca_channel__g_Ca_T_Periphery_1DCapable = 0.00694; // microS
        const double var_T_type_Ca_channel__g_Ca_T_Periphery_Published = 0.013899999999999999; // microS
        const double var_calcium_background_current__g_b_Ca_Centre_0DCapable = 1.3236e-5; // microS
        const double var_calcium_background_current__g_b_Ca_Centre_1DCapable = 1.323e-5; // microS
        const double var_calcium_background_current__g_b_Ca_Centre_Published = 1.3200000000000001e-5; // microS
        const double var_calcium_background_current__g_b_Ca_Periphery_0DCapable = 4.2951999999999998e-5; // microS
        const double var_calcium_background_current__g_b_Ca_Periphery_1DCapable = 4.2899999999999999e-5; // microS
        const double var_calcium_background_current__g_b_Ca_Periphery_Published = 4.3000000000000002e-5; // microS
        const double var_four_AP_sensitive_currents__g_sus_Centre_0DCapable = 6.6455040000000003e-5; // microS
        const double var_four_AP_sensitive_currents__g_sus_Centre_1DCapable = 0.00026600000000000001; // microS
        const double var_four_AP_sensitive_currents__g_sus_Centre_Published = 6.6500000000000004e-5; // microS
        const double var_four_AP_sensitive_currents__g_sus_Periphery_0DCapable = 0.01138376; // microS
        const double var_four_AP_sensitive_currents__g_sus_Periphery_1DCapable = 0.0114; // microS
        const double var_four_AP_sensitive_currents__g_sus_Periphery_Published = 0.0114; // microS
        const double var_four_AP_sensitive_currents__g_to_Centre_0DCapable = 0.0049049999999999996; // microS
        const double var_four_AP_sensitive_currents__g_to_Centre_1DCapable = 0.0049049999999999996; // microS
        const double var_four_AP_sensitive_currents__g_to_Centre_Published = 0.0049100000000000003; // microS
        const double var_four_AP_sensitive_currents__g_to_Periphery_0DCapable = 0.036495; // microS
        const double var_four_AP_sensitive_currents__g_to_Periphery_1DCapable = 0.036499999999999998; // microS
        const double var_four_AP_sensitive_currents__g_to_Periphery_Published = 0.036490000000000002; // microS
        const double var_hyperpolarisation_activated_current__g_f_K_Centre_0DCapable = 0.0005465; // microS
        const double var_hyperpolarisation_activated_current__g_f_K_Centre_1DCapable = 0.000437; // microS
        const double var_hyperpolarisation_activated_current__g_f_K_Centre_Published = 0.00054799999999999998; // microS
        const double var_hyperpolarisation_activated_current__g_f_K_Periphery_0DCapable = 0.006875; // microS
        const double var_hyperpolarisation_activated_current__g_f_K_Periphery_1DCapable = 0.0054999999999999997; // microS
        const double var_hyperpolarisation_activated_current__g_f_K_Periphery_Published = 0.0068999999999999999; // microS
        const double var_hyperpolarisation_activated_current__g_f_Na_Centre_0DCapable = 0.0005465; // microS
        const double var_hyperpolarisation_activated_current__g_f_Na_Centre_1DCapable = 0.000437; // microS
        const double var_hyperpolarisation_activated_current__g_f_Na_Centre_Published = 0.00054799999999999998; // microS
        const double var_hyperpolarisation_activated_current__g_f_Na_Periphery_0DCapable = 0.006875; // microS
        const double var_hyperpolarisation_activated_current__g_f_Na_Periphery_1DCapable = 0.0054999999999999997; // microS
        const double var_hyperpolarisation_activated_current__g_f_Na_Periphery_Published = 0.0068999999999999999; // microS
        const double var_ionic_concentrations__Ca_i = 0.0001; // millimolar
        const double var_ionic_concentrations__Ca_o = 2.0; // millimolar
        const double var_ionic_concentrations__K_i = 140.0; // millimolar
        const double var_ionic_concentrations__K_o = 5.4000000000000004; // millimolar
        const double var_ionic_concentrations__Na_i = 8.0; // millimolar
        const double var_ionic_concentrations__Na_o = 140.0; // millimolar
        const double var_membrane__F = 96845.0; // coulomb_per_mole
        const double var_membrane__FCellConstant = 1.0309347; // dimensionless
        const double var_membrane__R = 8314.0; // millijoule_per_mole_kelvin
        const double var_membrane__T = 310.0; // kelvin
        const double var_membrane__Version = 1.0; // dimensionless
        const double var_membrane__dCell = 0; // dimensionless
        const double var_membrane__FCell = ((var_membrane__Version == 0) ? (0.35666666666666669 * (-0.10000000000000001 + 3.0 * var_membrane__dCell) / (1.0 + 0.77449999999999997 * exp(6.9491525423728815 - 10.16949152542373 * var_membrane__dCell))) : ((var_membrane__Version == 1.0) ? (var_membrane__FCellConstant * var_membrane__dCell / (1.0 + 0.77449999999999997 * exp(6.9491525423728815 - 10.16949152542373 * var_membrane__dCell))) : (1.0343333333333333 * var_membrane__dCell / (1.0 + 0.77449999999999997 * exp(12.564102564102564 - 14.871794871794872 * var_membrane__dCell))))); // dimensionless
        const double var_L_type_Ca_channel__g_Ca_L = ((var_membrane__Version == 0) ? ((-var_L_type_Ca_channel__g_Ca_L_Centre_Published + var_L_type_Ca_channel__g_Ca_L_Periphery_Published) * var_membrane__FCell + var_L_type_Ca_channel__g_Ca_L_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_L_type_Ca_channel__g_Ca_L_Centre_0DCapable + var_L_type_Ca_channel__g_Ca_L_Periphery_0DCapable) * var_membrane__FCell + var_L_type_Ca_channel__g_Ca_L_Centre_0DCapable) : ((-var_L_type_Ca_channel__g_Ca_L_Centre_1DCapable + var_L_type_Ca_channel__g_Ca_L_Periphery_1DCapable) * var_membrane__FCell + var_L_type_Ca_channel__g_Ca_L_Centre_1DCapable))); // microS
        const double var_L_type_Ca_channel__i_Ca_L = (-var_L_type_Ca_channel__E_Ca_L + var_chaste_interface__membrane__V) * (0.0060000000000000001 / (1.0 + exp(-2.3500000000000001 - 0.16666666666666666 * var_chaste_interface__membrane__V)) + var_chaste_interface__L_type_Ca_channel_d_gate__d_L * var_chaste_interface__L_type_Ca_channel_f_gate__f_L) * var_L_type_Ca_channel__g_Ca_L; // nanoA
        const double var_T_type_Ca_channel__g_Ca_T = ((var_membrane__Version == 0) ? ((-var_T_type_Ca_channel__g_Ca_T_Centre_Published + var_T_type_Ca_channel__g_Ca_T_Periphery_Published) * var_membrane__FCell + var_T_type_Ca_channel__g_Ca_T_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_T_type_Ca_channel__g_Ca_T_Centre_0DCapable + var_T_type_Ca_channel__g_Ca_T_Periphery_0DCapable) * var_membrane__FCell + var_T_type_Ca_channel__g_Ca_T_Centre_0DCapable) : ((-var_T_type_Ca_channel__g_Ca_T_Centre_1DCapable + var_T_type_Ca_channel__g_Ca_T_Periphery_1DCapable) * var_membrane__FCell + var_T_type_Ca_channel__g_Ca_T_Centre_1DCapable))); // microS
        const double var_T_type_Ca_channel__i_Ca_T = (-var_T_type_Ca_channel__E_Ca_T + var_chaste_interface__membrane__V) * var_T_type_Ca_channel__g_Ca_T * var_chaste_interface__T_type_Ca_channel_d_gate__d_T * var_chaste_interface__T_type_Ca_channel_f_gate__f_T; // nanoA
        const double var_calcium_background_current__g_b_Ca = ((var_membrane__Version == 0) ? ((-var_calcium_background_current__g_b_Ca_Centre_Published + var_calcium_background_current__g_b_Ca_Periphery_Published) * var_membrane__FCell + var_calcium_background_current__g_b_Ca_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_calcium_background_current__g_b_Ca_Centre_0DCapable + var_calcium_background_current__g_b_Ca_Periphery_0DCapable) * var_membrane__FCell + var_calcium_background_current__g_b_Ca_Centre_0DCapable) : ((-var_calcium_background_current__g_b_Ca_Centre_1DCapable + var_calcium_background_current__g_b_Ca_Periphery_1DCapable) * var_membrane__FCell + var_calcium_background_current__g_b_Ca_Centre_1DCapable))); // microS
        const double var_four_AP_sensitive_currents__g_sus = ((var_membrane__Version == 0) ? ((-var_four_AP_sensitive_currents__g_sus_Centre_Published + var_four_AP_sensitive_currents__g_sus_Periphery_Published) * var_membrane__FCell + var_four_AP_sensitive_currents__g_sus_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_four_AP_sensitive_currents__g_sus_Centre_0DCapable + var_four_AP_sensitive_currents__g_sus_Periphery_0DCapable) * var_membrane__FCell + var_four_AP_sensitive_currents__g_sus_Centre_0DCapable) : ((-var_four_AP_sensitive_currents__g_sus_Centre_1DCapable + var_four_AP_sensitive_currents__g_sus_Periphery_1DCapable) * var_membrane__FCell + var_four_AP_sensitive_currents__g_sus_Centre_1DCapable))); // microS
        const double var_four_AP_sensitive_currents__g_to = ((var_membrane__Version == 0) ? ((-var_four_AP_sensitive_currents__g_to_Centre_Published + var_four_AP_sensitive_currents__g_to_Periphery_Published) * var_membrane__FCell + var_four_AP_sensitive_currents__g_to_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_four_AP_sensitive_currents__g_to_Centre_0DCapable + var_four_AP_sensitive_currents__g_to_Periphery_0DCapable) * var_membrane__FCell + var_four_AP_sensitive_currents__g_to_Centre_0DCapable) : ((-var_four_AP_sensitive_currents__g_to_Centre_1DCapable + var_four_AP_sensitive_currents__g_to_Periphery_1DCapable) * var_membrane__FCell + var_four_AP_sensitive_currents__g_to_Centre_1DCapable))); // microS
        const double var_hyperpolarisation_activated_current__g_f_K = ((var_membrane__Version == 0) ? ((-var_hyperpolarisation_activated_current__g_f_K_Centre_Published + var_hyperpolarisation_activated_current__g_f_K_Periphery_Published) * var_membrane__FCell + var_hyperpolarisation_activated_current__g_f_K_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_hyperpolarisation_activated_current__g_f_K_Centre_0DCapable + var_hyperpolarisation_activated_current__g_f_K_Periphery_0DCapable) * var_membrane__FCell + var_hyperpolarisation_activated_current__g_f_K_Centre_0DCapable) : ((-var_hyperpolarisation_activated_current__g_f_K_Centre_1DCapable + var_hyperpolarisation_activated_current__g_f_K_Periphery_1DCapable) * var_membrane__FCell + var_hyperpolarisation_activated_current__g_f_K_Centre_1DCapable))); // microS
        const double var_hyperpolarisation_activated_current__g_f_Na = ((var_membrane__Version == 0) ? ((-var_hyperpolarisation_activated_current__g_f_Na_Centre_Published + var_hyperpolarisation_activated_current__g_f_Na_Periphery_Published) * var_membrane__FCell + var_hyperpolarisation_activated_current__g_f_Na_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_hyperpolarisation_activated_current__g_f_Na_Centre_0DCapable + var_hyperpolarisation_activated_current__g_f_Na_Periphery_0DCapable) * var_membrane__FCell + var_hyperpolarisation_activated_current__g_f_Na_Centre_0DCapable) : ((-var_hyperpolarisation_activated_current__g_f_Na_Centre_1DCapable + var_hyperpolarisation_activated_current__g_f_Na_Periphery_1DCapable) * var_membrane__FCell + var_hyperpolarisation_activated_current__g_f_Na_Centre_1DCapable))); // microS
        const double var_persistent_calcium_current__i_Ca_p_max_Centre_0DCapable = 0; // nanoA
        const double var_persistent_calcium_current__i_Ca_p_max_Centre_1DCapable = 0.0041999999999999997; // nanoA
        const double var_persistent_calcium_current__i_Ca_p_max_Centre_Published = 0; // nanoA
        const double var_persistent_calcium_current__i_Ca_p_max_Periphery_0DCapable = 0; // nanoA
        const double var_persistent_calcium_current__i_Ca_p_max_Periphery_1DCapable = 0.033390000000000003; // nanoA
        const double var_persistent_calcium_current__i_Ca_p_max_Periphery_Published = 0; // nanoA
        const double var_persistent_calcium_current__i_Ca_p_max = ((var_membrane__Version == 0) ? ((-var_persistent_calcium_current__i_Ca_p_max_Centre_Published + var_persistent_calcium_current__i_Ca_p_max_Periphery_Published) * var_membrane__FCell + var_persistent_calcium_current__i_Ca_p_max_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_persistent_calcium_current__i_Ca_p_max_Centre_0DCapable + var_persistent_calcium_current__i_Ca_p_max_Periphery_0DCapable) * var_membrane__FCell + var_persistent_calcium_current__i_Ca_p_max_Centre_0DCapable) : ((-var_persistent_calcium_current__i_Ca_p_max_Centre_1DCapable + var_persistent_calcium_current__i_Ca_p_max_Periphery_1DCapable) * var_membrane__FCell + var_persistent_calcium_current__i_Ca_p_max_Centre_1DCapable))); // nanoA
        const double var_persistent_calcium_current__i_Ca_p = var_ionic_concentrations__Ca_i * var_persistent_calcium_current__i_Ca_p_max / (0.00040000000000000002 + var_ionic_concentrations__Ca_i); // nanoA
        const double var_potassium_background_current__g_b_K_Centre_0DCapable = 2.5236359999999998e-5; // microS
        const double var_potassium_background_current__g_b_K_Centre_1DCapable = 2.5199999999999999e-5; // microS
        const double var_potassium_background_current__g_b_K_Centre_Published = 2.5199999999999999e-5; // microS
        const double var_potassium_background_current__g_b_K_Periphery_0DCapable = 8.1891999999999995e-5; // microS
        const double var_potassium_background_current__g_b_K_Periphery_1DCapable = 8.1899999999999999e-5; // microS
        const double var_potassium_background_current__g_b_K_Periphery_Published = 8.1899999999999999e-5; // microS
        const double var_potassium_background_current__g_b_K = ((var_membrane__Version == 0) ? ((-var_potassium_background_current__g_b_K_Centre_Published + var_potassium_background_current__g_b_K_Periphery_Published) * var_membrane__FCell + var_potassium_background_current__g_b_K_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_potassium_background_current__g_b_K_Centre_0DCapable + var_potassium_background_current__g_b_K_Periphery_0DCapable) * var_membrane__FCell + var_potassium_background_current__g_b_K_Centre_0DCapable) : ((-var_potassium_background_current__g_b_K_Centre_1DCapable + var_potassium_background_current__g_b_K_Periphery_1DCapable) * var_membrane__FCell + var_potassium_background_current__g_b_K_Centre_1DCapable))); // microS
        const double var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_0DCapable = 0.00079704000000000005; // microS
        const double var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_1DCapable = 0.00073800000000000005; // microS
        const double var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_Published = 0.00079699999999999997; // microS
        const double var_rapid_delayed_rectifying_potassium_current__g_K_r_Periphery_0DCapable = 0.016; // microS
        const double var_rapid_delayed_rectifying_potassium_current__g_K_r_Periphery_1DCapable = 0.020799999999999999; // microS
        const double var_rapid_delayed_rectifying_potassium_current__g_K_r_Periphery_Published = 0.016; // microS
        const double var_rapid_delayed_rectifying_potassium_current__g_K_r = ((var_membrane__Version == 0) ? ((-var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_Published + var_rapid_delayed_rectifying_potassium_current__g_K_r_Periphery_Published) * var_membrane__FCell + var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_0DCapable + var_rapid_delayed_rectifying_potassium_current__g_K_r_Periphery_0DCapable) * var_membrane__FCell + var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_0DCapable) : ((-var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_1DCapable + var_rapid_delayed_rectifying_potassium_current__g_K_r_Periphery_1DCapable) * var_membrane__FCell + var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_1DCapable))); // microS
        const double var_rapid_delayed_rectifying_potassium_current__P_a = 0.40000000000000002 * var_chaste_interface__rapid_delayed_rectifying_potassium_current_P_as_gate__P_as + 0.59999999999999998 * var_chaste_interface__rapid_delayed_rectifying_potassium_current_P_af_gate__P_af; // dimensionless
        const double var_reversal_and_equilibrium_potentials__E_Ca = 0.5 * var_membrane__R * var_membrane__T * log(var_ionic_concentrations__Ca_o / var_ionic_concentrations__Ca_i) / var_membrane__F; // millivolt
        const double var_calcium_background_current__i_b_Ca = (-var_reversal_and_equilibrium_potentials__E_Ca + var_chaste_interface__membrane__V) * var_calcium_background_current__g_b_Ca; // nanoA
        const double var_reversal_and_equilibrium_potentials__E_K = var_membrane__R * var_membrane__T * log(var_ionic_concentrations__K_o / var_ionic_concentrations__K_i) / var_membrane__F; // millivolt
        const double var_four_AP_sensitive_currents__i_sus = (-var_reversal_and_equilibrium_potentials__E_K + var_chaste_interface__membrane__V) * var_four_AP_sensitive_currents__g_sus * var_chaste_interface__four_AP_sensitive_currents_r_gate__r; // nanoA
        const double var_four_AP_sensitive_currents__i_to = (-var_reversal_and_equilibrium_potentials__E_K + var_chaste_interface__membrane__V) * var_four_AP_sensitive_currents__g_to * var_chaste_interface__four_AP_sensitive_currents_q_gate__q * var_chaste_interface__four_AP_sensitive_currents_r_gate__r; // nanoA
        const double var_hyperpolarisation_activated_current__i_f_K = ((var_membrane__Version != 2.0) ? ((-var_reversal_and_equilibrium_potentials__E_K + var_chaste_interface__membrane__V) * var_hyperpolarisation_activated_current__g_f_K * var_chaste_interface__hyperpolarisation_activated_current_y_gate__y) : ((102.0 + var_chaste_interface__membrane__V) * var_hyperpolarisation_activated_current__g_f_K * var_chaste_interface__hyperpolarisation_activated_current_y_gate__y)); // nanoA
        const double var_potassium_background_current__i_b_K = (-var_reversal_and_equilibrium_potentials__E_K + var_chaste_interface__membrane__V) * var_potassium_background_current__g_b_K; // nanoA
        const double var_rapid_delayed_rectifying_potassium_current__i_K_r = (-var_reversal_and_equilibrium_potentials__E_K + var_chaste_interface__membrane__V) * var_rapid_delayed_rectifying_potassium_current__P_a * var_rapid_delayed_rectifying_potassium_current__g_K_r * var_chaste_interface__rapid_delayed_rectifying_potassium_current_P_i_gate__P_i; // nanoA
        const double var_reversal_and_equilibrium_potentials__E_K_s = ((var_membrane__Version == 0) ? (var_membrane__R * var_membrane__T * log((var_ionic_concentrations__K_o + 0.12 * var_ionic_concentrations__Na_o) / (var_ionic_concentrations__K_i + 0.12 * var_ionic_concentrations__Na_i)) / var_membrane__F) : (var_membrane__R * var_membrane__T * log((var_ionic_concentrations__K_o + 0.029999999999999999 * var_ionic_concentrations__Na_o) / (var_ionic_concentrations__K_i + 0.029999999999999999 * var_ionic_concentrations__Na_i)) / var_membrane__F)); // millivolt
        const double var_reversal_and_equilibrium_potentials__E_Na = var_membrane__R * var_membrane__T * log(var_ionic_concentrations__Na_o / var_ionic_concentrations__Na_i) / var_membrane__F; // millivolt
        const double var_hyperpolarisation_activated_current__i_f_Na = ((var_membrane__Version != 2.0) ? ((-var_reversal_and_equilibrium_potentials__E_Na + var_chaste_interface__membrane__V) * var_hyperpolarisation_activated_current__g_f_Na * var_chaste_interface__hyperpolarisation_activated_current_y_gate__y) : ((-77.599999999999994 + var_chaste_interface__membrane__V) * var_hyperpolarisation_activated_current__g_f_Na * var_chaste_interface__hyperpolarisation_activated_current_y_gate__y)); // nanoA
        const double var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_0DCapable = 0.00034450000000000003; // microS
        const double var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_1DCapable = 0.00034499999999999998; // microS
        const double var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_Published = 0.00051800000000000001; // microS
        const double var_slow_delayed_rectifying_potassium_current__g_K_s_Periphery_0DCapable = 0.0104; // microS
        const double var_slow_delayed_rectifying_potassium_current__g_K_s_Periphery_1DCapable = 0.0104; // microS
        const double var_slow_delayed_rectifying_potassium_current__g_K_s_Periphery_Published = 0.0104; // microS
        const double var_slow_delayed_rectifying_potassium_current__g_K_s = ((var_membrane__Version == 0) ? ((-var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_Published + var_slow_delayed_rectifying_potassium_current__g_K_s_Periphery_Published) * var_membrane__FCell + var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_0DCapable + var_slow_delayed_rectifying_potassium_current__g_K_s_Periphery_0DCapable) * var_membrane__FCell + var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_0DCapable) : ((-var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_1DCapable + var_slow_delayed_rectifying_potassium_current__g_K_s_Periphery_1DCapable) * var_membrane__FCell + var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_1DCapable))); // microS
        const double var_slow_delayed_rectifying_potassium_current__i_K_s = pow(var_chaste_interface__slow_delayed_rectifying_potassium_current_xs_gate__xs, 2) * (-var_reversal_and_equilibrium_potentials__E_K_s + var_chaste_interface__membrane__V) * var_slow_delayed_rectifying_potassium_current__g_K_s; // nanoA
        const double var_sodium_background_current__g_b_Na_Centre_0DCapable = 5.8181799999999999e-5; // microS
        const double var_sodium_background_current__g_b_Na_Centre_1DCapable = 5.8e-5; // microS
        const double var_sodium_background_current__g_b_Na_Centre_Published = 5.8e-5; // microS
        const double var_sodium_background_current__g_b_Na_Periphery_0DCapable = 0.00018880000000000001; // microS
        const double var_sodium_background_current__g_b_Na_Periphery_1DCapable = 0.00018900000000000001; // microS
        const double var_sodium_background_current__g_b_Na_Periphery_Published = 0.00018900000000000001; // microS
        const double var_sodium_background_current__g_b_Na = ((var_membrane__Version == 0) ? ((-var_sodium_background_current__g_b_Na_Centre_Published + var_sodium_background_current__g_b_Na_Periphery_Published) * var_membrane__FCell + var_sodium_background_current__g_b_Na_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_sodium_background_current__g_b_Na_Centre_0DCapable + var_sodium_background_current__g_b_Na_Periphery_0DCapable) * var_membrane__FCell + var_sodium_background_current__g_b_Na_Centre_0DCapable) : ((-var_sodium_background_current__g_b_Na_Centre_1DCapable + var_sodium_background_current__g_b_Na_Periphery_1DCapable) * var_membrane__FCell + var_sodium_background_current__g_b_Na_Centre_1DCapable))); // microS
        const double var_sodium_background_current__i_b_Na = (-var_reversal_and_equilibrium_potentials__E_Na + var_chaste_interface__membrane__V) * var_sodium_background_current__g_b_Na; // nanoA
        const double var_sodium_calcium_exchanger__d_NaCa = 0.0001; // dimensionless
        const double var_sodium_calcium_exchanger__gamma_NaCa = 0.5; // dimensionless
        const double var_sodium_calcium_exchanger__k_NaCa_Centre_0DCapable = 2.7228999999999998e-6; // nanoA
        const double var_sodium_calcium_exchanger__k_NaCa_Centre_1DCapable = 2.7999999999999999e-6; // nanoA
        const double var_sodium_calcium_exchanger__k_NaCa_Centre_Published = 2.7e-6; // nanoA
        const double var_sodium_calcium_exchanger__k_NaCa_Periphery_0DCapable = 8.8358400000000004e-6; // nanoA
        const double var_sodium_calcium_exchanger__k_NaCa_Periphery_1DCapable = 8.8000000000000004e-6; // nanoA
        const double var_sodium_calcium_exchanger__k_NaCa_Periphery_Published = 8.8000000000000004e-6; // nanoA
        const double var_sodium_calcium_exchanger__k_NaCa = ((var_membrane__Version == 0) ? ((-var_sodium_calcium_exchanger__k_NaCa_Centre_Published + var_sodium_calcium_exchanger__k_NaCa_Periphery_Published) * var_membrane__FCell + var_sodium_calcium_exchanger__k_NaCa_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_sodium_calcium_exchanger__k_NaCa_Centre_0DCapable + var_sodium_calcium_exchanger__k_NaCa_Periphery_0DCapable) * var_membrane__FCell + var_sodium_calcium_exchanger__k_NaCa_Centre_0DCapable) : ((-var_sodium_calcium_exchanger__k_NaCa_Centre_1DCapable + var_sodium_calcium_exchanger__k_NaCa_Periphery_1DCapable) * var_membrane__FCell + var_sodium_calcium_exchanger__k_NaCa_Centre_1DCapable))); // nanoA
        const double var_sodium_calcium_exchanger__i_NaCa = ((var_membrane__Version == 0) ? ((pow(var_ionic_concentrations__Na_i, 3) * var_ionic_concentrations__Ca_o * exp(0.037429999999999998 * var_chaste_interface__membrane__V * var_sodium_calcium_exchanger__gamma_NaCa) - pow(var_ionic_concentrations__Na_o, 3) * var_ionic_concentrations__Ca_i * exp(0.037400000000000003 * (-1.0 + var_sodium_calcium_exchanger__gamma_NaCa) * var_chaste_interface__membrane__V)) * var_sodium_calcium_exchanger__k_NaCa / (1.0 + (pow(var_ionic_concentrations__Na_i, 3) * var_ionic_concentrations__Ca_o + pow(var_ionic_concentrations__Na_o, 3) * var_ionic_concentrations__Ca_i) * var_sodium_calcium_exchanger__d_NaCa)) : ((pow(var_ionic_concentrations__Na_i, 3) * var_ionic_concentrations__Ca_o * exp(0.037429999999999998 * var_chaste_interface__membrane__V * var_sodium_calcium_exchanger__gamma_NaCa) - pow(var_ionic_concentrations__Na_o, 3) * var_ionic_concentrations__Ca_i * exp(0.037429999999999998 * (-1.0 + var_sodium_calcium_exchanger__gamma_NaCa) * var_chaste_interface__membrane__V)) * var_sodium_calcium_exchanger__k_NaCa / (1.0 + (pow(var_ionic_concentrations__Na_i, 3) * var_ionic_concentrations__Ca_o + pow(var_ionic_concentrations__Na_o, 3) * var_ionic_concentrations__Ca_i) * var_sodium_calcium_exchanger__d_NaCa))); // nanoA
        const double var_sodium_current__g_Na_Centre_0DCapable = 0; // microlitre_per_second
        const double var_sodium_current__g_Na_Centre_1DCapable = 0; // microlitre_per_second
        const double var_sodium_current__g_Na_Centre_Published = 0; // microlitre_per_second
        const double var_sodium_current__g_Na_Periphery_0DCapable = 1.204e-6; // microlitre_per_second
        const double var_sodium_current__g_Na_Periphery_1DCapable = 3.7e-7; // microlitre_per_second
        const double var_sodium_current__g_Na_Periphery_Published = 1.1999999999999999e-6; // microlitre_per_second
        const double var_sodium_current__g_Na = ((var_membrane__Version == 0) ? ((-var_sodium_current__g_Na_Centre_Published + var_sodium_current__g_Na_Periphery_Published) * var_membrane__FCell + var_sodium_current__g_Na_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_sodium_current__g_Na_Centre_0DCapable + var_sodium_current__g_Na_Periphery_0DCapable) * var_membrane__FCell + var_sodium_current__g_Na_Centre_0DCapable) : ((-var_sodium_current__g_Na_Centre_1DCapable + var_sodium_current__g_Na_Periphery_1DCapable) * var_membrane__FCell + var_sodium_current__g_Na_Centre_1DCapable))); // microlitre_per_second
        const double var_sodium_current_h_gate__F_Na = ((var_membrane__Version == 0) ? (0.086900000000000005 + 0.095200000000000007 * exp(-2.1671999999999998 - 0.063 * var_chaste_interface__membrane__V) / (1.0 + 1.6599999999999999 * exp(-14.332500000000001 - 0.22500000000000001 * var_chaste_interface__membrane__V))) : (0.086929999999999993 + 0.095180000000000001 * exp(-2.1692640000000001 - 0.063060000000000005 * var_chaste_interface__membrane__V) / (1.0 + 1.6619999999999999 * exp(-14.33887 - 0.22509999999999999 * var_chaste_interface__membrane__V)))); // dimensionless
        const double var_sodium_current_h_gate__h = (1.0 - var_sodium_current_h_gate__F_Na) * var_chaste_interface__sodium_current_h_gate__h1 + var_sodium_current_h_gate__F_Na * var_chaste_interface__sodium_current_h_gate__h2; // dimensionless
        const double var_sodium_current__i_Na = pow(var_membrane__F, 2) * pow(var_chaste_interface__sodium_current_m_gate__m, 3) * (-1.0 + exp((-var_reversal_and_equilibrium_potentials__E_Na + var_chaste_interface__membrane__V) * var_membrane__F / (var_membrane__R * var_membrane__T))) * var_ionic_concentrations__Na_o * var_chaste_interface__membrane__V * var_sodium_current__g_Na * var_sodium_current_h_gate__h / ((-1.0 + exp(var_membrane__F * var_chaste_interface__membrane__V / (var_membrane__R * var_membrane__T))) * var_membrane__R * var_membrane__T); // nanoA
        const double var_sodium_potassium_pump__K_m_K = 0.621; // millimolar
        const double var_sodium_potassium_pump__K_m_Na = 5.6399999999999997; // millimolar
        const double var_sodium_potassium_pump__i_p_max_Centre_0DCapable = 0.047825449999999999; // nanoA
        const double var_sodium_potassium_pump__i_p_max_Centre_1DCapable = 0.047800000000000002; // nanoA
        const double var_sodium_potassium_pump__i_p_max_Centre_Published = 0.047800000000000002; // nanoA
        const double var_sodium_potassium_pump__i_p_max_Periphery_0DCapable = 0.15519359999999999; // nanoA
        const double var_sodium_potassium_pump__i_p_max_Periphery_1DCapable = 0.16; // nanoA
        const double var_sodium_potassium_pump__i_p_max_Periphery_Published = 0.16; // nanoA
        const double var_sodium_potassium_pump__i_p_max = ((var_membrane__Version == 0) ? ((-var_sodium_potassium_pump__i_p_max_Centre_Published + var_sodium_potassium_pump__i_p_max_Periphery_Published) * var_membrane__FCell + var_sodium_potassium_pump__i_p_max_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_sodium_potassium_pump__i_p_max_Centre_0DCapable + var_sodium_potassium_pump__i_p_max_Periphery_0DCapable) * var_membrane__FCell + var_sodium_potassium_pump__i_p_max_Centre_0DCapable) : ((-var_sodium_potassium_pump__i_p_max_Centre_1DCapable + var_sodium_potassium_pump__i_p_max_Periphery_1DCapable) * var_membrane__FCell + var_sodium_potassium_pump__i_p_max_Centre_1DCapable))); // nanoA
        const double var_sodium_potassium_pump__i_p = 1.6000000000000001 * pow(var_ionic_concentrations__K_o, 2) * pow(var_ionic_concentrations__Na_i, 3) * var_sodium_potassium_pump__i_p_max / ((1.5 + exp(-1.5 - 0.025000000000000001 * var_chaste_interface__membrane__V)) * pow((var_ionic_concentrations__K_o + var_sodium_potassium_pump__K_m_K), 2) * pow((var_ionic_concentrations__Na_i + var_sodium_potassium_pump__K_m_Na), 3)); // nanoA
        const double var_chaste_interface__i_ionic = 0.001 * (var_L_type_Ca_channel__i_Ca_L + var_T_type_Ca_channel__i_Ca_T + var_calcium_background_current__i_b_Ca + var_four_AP_sensitive_currents__i_sus + var_four_AP_sensitive_currents__i_to + var_hyperpolarisation_activated_current__i_f_K + var_hyperpolarisation_activated_current__i_f_Na + var_persistent_calcium_current__i_Ca_p + var_potassium_background_current__i_b_K + var_rapid_delayed_rectifying_potassium_current__i_K_r + var_slow_delayed_rectifying_potassium_current__i_K_s + var_sodium_background_current__i_b_Na + var_sodium_calcium_exchanger__i_NaCa + var_sodium_current__i_Na + var_sodium_potassium_pump__i_p) * HeartConfig::Instance()->GetCapacitance(); // uA_per_cm2

        const double i_ionic = var_chaste_interface__i_ionic;
        EXCEPT_IF_NOT(!std::isnan(i_ionic));
        return i_ionic;
    }

    void Cellzhang_SAN_model_2000_allFromCellMLRushLarsen::EvaluateEquations(double var_chaste_interface__environment__time_converted, std::vector<double> &rDY, std::vector<double> &rAlphaOrTau, std::vector<double> &rBetaOrInf)
    {
        std::vector<double>& rY = rGetStateVariables();
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : rY[0]);
        // Units: millivolt; Initial value: -39.013558536
        double var_chaste_interface__sodium_current_m_gate__m = rY[1];
        // Units: dimensionless; Initial value: 0.092361701692
        double var_chaste_interface__sodium_current_h_gate__h1 = rY[2];
        // Units: dimensionless; Initial value: 0.015905380261
        double var_chaste_interface__sodium_current_h_gate__h2 = rY[3];
        // Units: dimensionless; Initial value: 0.01445216109
        double var_chaste_interface__L_type_Ca_channel_d_gate__d_L = rY[4];
        // Units: dimensionless; Initial value: 0.04804900895
        double var_chaste_interface__L_type_Ca_channel_f_gate__f_L = rY[5];
        // Units: dimensionless; Initial value: 0.48779845203
        double var_chaste_interface__T_type_Ca_channel_d_gate__d_T = rY[6];
        // Units: dimensionless; Initial value: 0.42074047435
        double var_chaste_interface__T_type_Ca_channel_f_gate__f_T = rY[7];
        // Units: dimensionless; Initial value: 0.038968420558
        double var_chaste_interface__four_AP_sensitive_currents_q_gate__q = rY[8];
        // Units: dimensionless; Initial value: 0.29760539675
        double var_chaste_interface__four_AP_sensitive_currents_r_gate__r = rY[9];
        // Units: dimensionless; Initial value: 0.064402950262
        double var_chaste_interface__rapid_delayed_rectifying_potassium_current_P_af_gate__P_af = rY[10];
        // Units: dimensionless; Initial value: 0.13034201158
        double var_chaste_interface__rapid_delayed_rectifying_potassium_current_P_as_gate__P_as = rY[11];
        // Units: dimensionless; Initial value: 0.46960956028
        double var_chaste_interface__rapid_delayed_rectifying_potassium_current_P_i_gate__P_i = rY[12];
        // Units: dimensionless; Initial value: 0.87993375273
        double var_chaste_interface__slow_delayed_rectifying_potassium_current_xs_gate__xs = rY[13];
        // Units: dimensionless; Initial value: 0.082293827208
        double var_chaste_interface__hyperpolarisation_activated_current_y_gate__y = rY[14];
        // Units: dimensionless; Initial value: 0.03889291759

        // Mathematics
        double d_dt_chaste_interface_var_membrane__V;
        const double var_membrane__FCellConstant = 1.0309347; // dimensionless
        const double var_L_type_Ca_channel_f_gate__f_L_infinity = 1 / (1.0 + exp(9.0 + 0.20000000000000001 * var_chaste_interface__membrane__V)); // dimensionless
        const double var_T_type_Ca_channel_d_gate__alpha_d_T = 1068.0 * exp(0.87666666666666671 + 0.033333333333333333 * var_chaste_interface__membrane__V); // per_second
        const double var_T_type_Ca_channel_d_gate__beta_d_T = 1068.0 * exp(-0.87666666666666671 - 0.033333333333333333 * var_chaste_interface__membrane__V); // per_second
        const double var_T_type_Ca_channel_d_gate__d_T_infinity = 1 / (1.0 + exp(-5.4411764705882355 - 0.14705882352941177 * var_chaste_interface__membrane__V)); // dimensionless
        const double var_T_type_Ca_channel_d_gate__tau_d_T = 1 / (var_T_type_Ca_channel_d_gate__alpha_d_T + var_T_type_Ca_channel_d_gate__beta_d_T); // second
        const double var_T_type_Ca_channel_f_gate__f_T_infinity = 1 / (1.0 + exp(7.8888888888888893 + 0.1111111111111111 * var_chaste_interface__membrane__V)); // dimensionless
        const double var_four_AP_sensitive_currents_q_gate__q_infinity = 1 / (1.0 + exp(4.5320610687022898 + 0.076335877862595422 * var_chaste_interface__membrane__V)); // dimensionless
        const double var_four_AP_sensitive_currents_r_gate__r_infinity = 1 / (1.0 + exp(0.5548223350253807 - 0.050761421319796954 * var_chaste_interface__membrane__V)); // dimensionless
        const double var_hyperpolarisation_activated_current_y_gate__beta_y = exp(3.5355294117647058 + 0.047058823529411764 * var_chaste_interface__membrane__V); // per_second
        const double var_membrane__Version = 1.0; // dimensionless
        const double var_L_type_Ca_channel_d_gate__alpha_d_L = ((var_membrane__Version == 0) ? (-84.900000000000006 * var_chaste_interface__membrane__V / (-1.0 + exp(-0.20799999999999999 * var_chaste_interface__membrane__V)) - 28.379999999999999 * (35.0 + var_chaste_interface__membrane__V) / (-1.0 + exp(-14.0 - 0.40000000000000002 * var_chaste_interface__membrane__V))) : ((var_membrane__Version == 1.0) ? (-28.390000000000001 * (35.0 + var_chaste_interface__membrane__V) / (-1.0 + exp(-14.0 - 0.40000000000000002 * var_chaste_interface__membrane__V)) - 84.900000000000006 * var_chaste_interface__membrane__V / (-1.0 + exp(-0.20799999999999999 * var_chaste_interface__membrane__V))) : (-84.900000000000006 * var_chaste_interface__membrane__V / (-1.0 + exp(-0.20799999999999999 * var_chaste_interface__membrane__V)) - 28.399999999999999 * (35.0 + var_chaste_interface__membrane__V) / (-1.0 + exp(-14.0 - 0.40000000000000002 * var_chaste_interface__membrane__V))))); // per_second
        const double var_L_type_Ca_channel_d_gate__beta_d_L = ((var_membrane__Version == 1.0) ? (11.43 * (-5.0 + var_chaste_interface__membrane__V) / (-1.0 + exp(-2.0 + 0.40000000000000002 * var_chaste_interface__membrane__V))) : (11.42 * (-5.0 + var_chaste_interface__membrane__V) / (-1.0 + exp(-2.0 + 0.40000000000000002 * var_chaste_interface__membrane__V)))); // per_second
        const double var_L_type_Ca_channel_d_gate__tau_d_L = 2.0 / (var_L_type_Ca_channel_d_gate__alpha_d_L + var_L_type_Ca_channel_d_gate__beta_d_L); // second
        const double var_L_type_Ca_channel_f_gate__alpha_f_L = ((var_membrane__Version == 1.0) ? (3.75 * (28.0 + var_chaste_interface__membrane__V) / (-1.0 + exp(7.0 + 0.25 * var_chaste_interface__membrane__V))) : (3.1200000000000001 * (28.0 + var_chaste_interface__membrane__V) / (-1.0 + exp(7.0 + 0.25 * var_chaste_interface__membrane__V)))); // per_second
        const double var_L_type_Ca_channel_f_gate__beta_f_L = ((var_membrane__Version == 1.0) ? (30.0 / (1.0 + exp(-7.0 - 0.25 * var_chaste_interface__membrane__V))) : (25.0 / (1.0 + exp(-7.0 - 0.25 * var_chaste_interface__membrane__V)))); // per_second
        const double var_T_type_Ca_channel_f_gate__beta_f_T = ((var_membrane__Version == 1.0) ? (15.0 * exp(4.6163849154746419 + 0.065019505851755519 * var_chaste_interface__membrane__V)) : (15.0 * exp(4.6618985695708712 + 0.065019505851755519 * var_chaste_interface__membrane__V))); // per_second
        const double var_four_AP_sensitive_currents_r_gate__tau_r = ((var_membrane__Version == 0) ? (0.00298 + 0.01559 / (1.0369999999999999 * exp(2.7548999999999997 + 0.089999999999999997 * var_chaste_interface__membrane__V) + 0.36899999999999999 * exp(-2.8607999999999998 - 0.12 * var_chaste_interface__membrane__V))) : ((var_membrane__Version == 1.0) ? (0.0029775000000000001 + 0.019595000000000001 / (1.0369999999999999 * exp(2.7585732000000003 + 0.090120000000000006 * var_chaste_interface__membrane__V) + 0.36899999999999999 * exp(-2.8369599999999999 - 0.11899999999999999 * var_chaste_interface__membrane__V))) : (0.00298 + 0.01959 / (1.0369999999999999 * exp(2.7585732000000003 + 0.090120000000000006 * var_chaste_interface__membrane__V) + 0.36899999999999999 * exp(-2.8369599999999999 - 0.11899999999999999 * var_chaste_interface__membrane__V))))); // second
        const double var_hyperpolarisation_activated_current_y_gate__alpha_y = ((var_membrane__Version == 0) ? (exp(-2.9643125469571747 - 0.037565740045078885 * var_chaste_interface__membrane__V)) : (exp(-2.9631993991738641 - 0.037551633496057078 * var_chaste_interface__membrane__V))); // per_second
        const double var_membrane__dCell = 0; // dimensionless
        const double var_membrane__FCell = ((var_membrane__Version == 0) ? (0.35666666666666669 * (-0.10000000000000001 + 3.0 * var_membrane__dCell) / (1.0 + 0.77449999999999997 * exp(6.9491525423728815 - 10.16949152542373 * var_membrane__dCell))) : ((var_membrane__Version == 1.0) ? (var_membrane__FCellConstant * var_membrane__dCell / (1.0 + 0.77449999999999997 * exp(6.9491525423728815 - 10.16949152542373 * var_membrane__dCell))) : (1.0343333333333333 * var_membrane__dCell / (1.0 + 0.77449999999999997 * exp(12.564102564102564 - 14.871794871794872 * var_membrane__dCell))))); // dimensionless
        const double var_L_type_Ca_channel_d_gate__d_L_infinity = ((var_membrane__Version == 0) ? (1 / (1.0 + exp(-3.8500000000000001 - 0.16666666666666666 * var_chaste_interface__membrane__V))) : ((var_membrane__Version == 1.0) ? (1 / (1.0 + exp(-3.7166666666666668 - 0.13333333333333333 * var_membrane__FCell - 0.16666666666666666 * var_chaste_interface__membrane__V))) : (1 / (1.0 + exp(-3.6999999999999997 - 0.16666666666666666 * var_chaste_interface__membrane__V))))); // dimensionless
        const double var_L_type_Ca_channel_f_gate__tau_f_L = ((var_membrane__Version == 1.0) ? ((1.2 - 0.20000000000000001 * var_membrane__FCell) / (var_L_type_Ca_channel_f_gate__alpha_f_L + var_L_type_Ca_channel_f_gate__beta_f_L)) : (1 / (var_L_type_Ca_channel_f_gate__alpha_f_L + var_L_type_Ca_channel_f_gate__beta_f_L))); // second
        const double var_T_type_Ca_channel_f_gate__alpha_f_T = ((var_membrane__Version == 1.0) ? (15.300000000000001 * exp(-0.85234093637454988 - 0.0084033613445378148 * var_membrane__FCell - 0.012004801920768308 * var_chaste_interface__membrane__V)) : (15.300000000000001 * exp(-0.86074429771908767 - 0.012004801920768308 * var_chaste_interface__membrane__V))); // per_second
        const double var_T_type_Ca_channel_f_gate__tau_f_T = 1 / (var_T_type_Ca_channel_f_gate__alpha_f_T + var_T_type_Ca_channel_f_gate__beta_f_T); // second
        const double var_four_AP_sensitive_currents_q_gate__tau_q = ((var_membrane__Version == 0) ? (0.0101 + 2.4000000000000001e-5 * exp(5.093 + 0.10000000000000001 * var_chaste_interface__membrane__V) + 0.11433333333333336 / exp(-3.9199999999999999 - 0.080000000000000002 * var_chaste_interface__membrane__V)) : ((var_membrane__Version == 1.0) ? (0.010103333333333334 + 0.065166666666666664 / (0.56859999999999999 * exp(-3.1827900000000002 - 0.081610000000000002 * var_chaste_interface__membrane__V - 0.81610000000000005 * var_membrane__FCell) + 0.71740000000000004 * exp((0.27189999999999998 - 0.1719 * var_membrane__FCell) * (40.93 + 10.0 * var_membrane__FCell + var_chaste_interface__membrane__V)))) : (0.0101 + 0.065170000000000006 / (0.56859999999999999 * exp(-3.1827900000000002 - 0.081610000000000002 * var_chaste_interface__membrane__V) + 0.71740000000000004 * exp(11.128867 + 0.27189999999999998 * var_chaste_interface__membrane__V))))); // second
        const double var_rapid_delayed_rectifying_potassium_current_P_af_gate__P_af_infinity = ((var_membrane__Version != 2.0) ? (1 / (1.0 + exp(-1.3396226415094339 - 0.094339622641509441 * var_chaste_interface__membrane__V))) : (1 / (1.0 + exp(-1.2452830188679245 - 0.094339622641509441 * var_chaste_interface__membrane__V)))); // dimensionless
        const double var_rapid_delayed_rectifying_potassium_current_P_af_gate__tau_P_af = ((var_membrane__Version != 2.0) ? (1 / (0.95999999999999996 * exp(0.40000000000000002 - 0.044444444444444446 * var_chaste_interface__membrane__V) + 37.200000000000003 * exp(-0.56603773584905659 + 0.062893081761006289 * var_chaste_interface__membrane__V))) : (1 / (0.95999999999999996 * exp(0.44444444444444442 - 0.044444444444444446 * var_chaste_interface__membrane__V) + 37.200000000000003 * exp(-0.62893081761006286 + 0.062893081761006289 * var_chaste_interface__membrane__V)))); // second
        const double var_rapid_delayed_rectifying_potassium_current_P_as_gate__P_as_infinity = var_rapid_delayed_rectifying_potassium_current_P_af_gate__P_af_infinity; // dimensionless
        const double var_rapid_delayed_rectifying_potassium_current_P_as_gate__tau_P_as = ((var_membrane__Version != 2.0) ? (1 / (4.2000000000000002 * exp(-0.52941176470588236 + 0.058823529411764705 * var_chaste_interface__membrane__V) + 0.14999999999999999 * exp(0.41666666666666663 - 0.046296296296296294 * var_chaste_interface__membrane__V))) : (1 / (4.2000000000000002 * exp(-0.58823529411764708 + 0.058823529411764705 * var_chaste_interface__membrane__V) + 0.14999999999999999 * exp(0.46296296296296291 - 0.046296296296296294 * var_chaste_interface__membrane__V)))); // second
        const double var_rapid_delayed_rectifying_potassium_current_P_i_gate__P_i_infinity = 1 / (1.0 + exp(1.8415841584158419 + 0.099009900990099015 * var_chaste_interface__membrane__V)); // dimensionless
        const double var_rapid_delayed_rectifying_potassium_current_P_i_gate__tau_P_i = (((var_membrane__Version == 0) || (var_membrane__Version == 1.0)) ? (0.002) : (0.0060000000000000001)); // second
        const double var_slow_delayed_rectifying_potassium_current_xs_gate__alpha_xs = 14.0 / (1.0 + exp(4.4444444444444446 - 0.1111111111111111 * var_chaste_interface__membrane__V)); // per_second
        const double var_slow_delayed_rectifying_potassium_current_xs_gate__beta_xs = exp(-0.022222222222222223 * var_chaste_interface__membrane__V); // per_second
        const double var_sodium_current_h_gate__h1_infinity = 1 / (1.0 + exp(10.328124999999998 + 0.15625 * var_chaste_interface__membrane__V)); // dimensionless
        const double var_sodium_current_h_gate__h2_infinity = var_sodium_current_h_gate__h1_infinity; // dimensionless
        const double var_sodium_current_h_gate__tau_h1 = 0.00059770000000000005 + 3.7170000000000002e-6 * exp(-4.8164649999999991 - 0.28149999999999997 * var_chaste_interface__membrane__V) / (1.0 + 0.0037320000000000001 * exp(-12.936576000000001 - 0.34260000000000002 * var_chaste_interface__membrane__V)); // second
        const double var_sodium_current_h_gate__tau_h2 = 0.0035560000000000001 + 3.1860000000000002e-8 * exp(-11.69172 - 0.62190000000000001 * var_chaste_interface__membrane__V) / (1.0 + 7.1890000000000005e-5 * exp(-22.768981 - 0.66830000000000001 * var_chaste_interface__membrane__V)); // second
        const double var_sodium_current_m_gate__m_infinity = ((var_membrane__Version == 0) ? (pow(1 / (1.0 + exp(-0.18315018315018314 * var_chaste_interface__membrane__V)), 0.33333333333333331)) : (pow(1 / (1.0 + exp(-5.5531135531135529 - 0.18315018315018314 * var_chaste_interface__membrane__V)), 0.33333333333333331))); // dimensionless
        const double var_sodium_current_m_gate__tau_m = ((var_membrane__Version == 0) ? (4.0000000000000003e-5 + 0.00062469999999999995 / (0.627 * exp(5.330820000000001 + 0.082000000000000003 * var_chaste_interface__membrane__V) + 0.83199999999999996 * exp(-18.994500000000002 - 0.33500000000000002 * var_chaste_interface__membrane__V))) : (4.5689999999999998e-5 + 0.00062469999999999995 / (0.62739999999999996 * exp(5.3505781299999997 + 0.082299999999999998 * var_chaste_interface__membrane__V) + 0.83221659999999997 * exp(-19.034003092000003 - 0.33566000000000001 * var_chaste_interface__membrane__V)))); // second

        if (mSetVoltageDerivativeToZero)
        {
            d_dt_chaste_interface_var_membrane__V = 0.0;
        }
        else
        {
            const double var_L_type_Ca_channel__E_Ca_L = 46.399999999999999; // millivolt
            const double var_L_type_Ca_channel__g_Ca_L_Centre_0DCapable = 0.0057938; // microS
            const double var_L_type_Ca_channel__g_Ca_L_Centre_1DCapable = 0.0082000000000000007; // microS
            const double var_L_type_Ca_channel__g_Ca_L_Centre_Published = 0.0057999999999999996; // microS
            const double var_L_type_Ca_channel__g_Ca_L_Periphery_0DCapable = 0.065886479999999997; // microS
            const double var_L_type_Ca_channel__g_Ca_L_Periphery_1DCapable = 0.0659; // microS
            const double var_L_type_Ca_channel__g_Ca_L_Periphery_Published = 0.0659; // microS
            const double var_T_type_Ca_channel__E_Ca_T = 45.0; // millivolt
            const double var_T_type_Ca_channel__g_Ca_T_Centre_0DCapable = 0.0042780600000000002; // microS
            const double var_T_type_Ca_channel__g_Ca_T_Centre_1DCapable = 0.0020999999999999999; // microS
            const double var_T_type_Ca_channel__g_Ca_T_Centre_Published = 0.0043; // microS
            const double var_T_type_Ca_channel__g_Ca_T_Periphery_0DCapable = 0.0138823; // microS
            const double var_T_type_Ca_channel__g_Ca_T_Periphery_1DCapable = 0.00694; // microS
            const double var_T_type_Ca_channel__g_Ca_T_Periphery_Published = 0.013899999999999999; // microS
            const double var_calcium_background_current__g_b_Ca_Centre_0DCapable = 1.3236e-5; // microS
            const double var_calcium_background_current__g_b_Ca_Centre_1DCapable = 1.323e-5; // microS
            const double var_calcium_background_current__g_b_Ca_Centre_Published = 1.3200000000000001e-5; // microS
            const double var_calcium_background_current__g_b_Ca_Periphery_0DCapable = 4.2951999999999998e-5; // microS
            const double var_calcium_background_current__g_b_Ca_Periphery_1DCapable = 4.2899999999999999e-5; // microS
            const double var_calcium_background_current__g_b_Ca_Periphery_Published = 4.3000000000000002e-5; // microS
            const double var_four_AP_sensitive_currents__g_sus_Centre_0DCapable = 6.6455040000000003e-5; // microS
            const double var_four_AP_sensitive_currents__g_sus_Centre_1DCapable = 0.00026600000000000001; // microS
            const double var_four_AP_sensitive_currents__g_sus_Centre_Published = 6.6500000000000004e-5; // microS
            const double var_four_AP_sensitive_currents__g_sus_Periphery_0DCapable = 0.01138376; // microS
            const double var_four_AP_sensitive_currents__g_sus_Periphery_1DCapable = 0.0114; // microS
            const double var_four_AP_sensitive_currents__g_sus_Periphery_Published = 0.0114; // microS
            const double var_four_AP_sensitive_currents__g_to_Centre_0DCapable = 0.0049049999999999996; // microS
            const double var_four_AP_sensitive_currents__g_to_Centre_1DCapable = 0.0049049999999999996; // microS
            const double var_four_AP_sensitive_currents__g_to_Centre_Published = 0.0049100000000000003; // microS
            const double var_four_AP_sensitive_currents__g_to_Periphery_0DCapable = 0.036495; // microS
            const double var_four_AP_sensitive_currents__g_to_Periphery_1DCapable = 0.036499999999999998; // microS
            const double var_four_AP_sensitive_currents__g_to_Periphery_Published = 0.036490000000000002; // microS
            const double var_hyperpolarisation_activated_current__g_f_K_Centre_0DCapable = 0.0005465; // microS
            const double var_hyperpolarisation_activated_current__g_f_K_Centre_1DCapable = 0.000437; // microS
            const double var_hyperpolarisation_activated_current__g_f_K_Centre_Published = 0.00054799999999999998; // microS
            const double var_hyperpolarisation_activated_current__g_f_K_Periphery_0DCapable = 0.006875; // microS
            const double var_hyperpolarisation_activated_current__g_f_K_Periphery_1DCapable = 0.0054999999999999997; // microS
            const double var_hyperpolarisation_activated_current__g_f_K_Periphery_Published = 0.0068999999999999999; // microS
            const double var_hyperpolarisation_activated_current__g_f_Na_Centre_0DCapable = 0.0005465; // microS
            const double var_hyperpolarisation_activated_current__g_f_Na_Centre_1DCapable = 0.000437; // microS
            const double var_hyperpolarisation_activated_current__g_f_Na_Centre_Published = 0.00054799999999999998; // microS
            const double var_hyperpolarisation_activated_current__g_f_Na_Periphery_0DCapable = 0.006875; // microS
            const double var_hyperpolarisation_activated_current__g_f_Na_Periphery_1DCapable = 0.0054999999999999997; // microS
            const double var_hyperpolarisation_activated_current__g_f_Na_Periphery_Published = 0.0068999999999999999; // microS
            const double var_ionic_concentrations__Ca_i = 0.0001; // millimolar
            const double var_ionic_concentrations__Ca_o = 2.0; // millimolar
            const double var_ionic_concentrations__K_i = 140.0; // millimolar
            const double var_ionic_concentrations__K_o = 5.4000000000000004; // millimolar
            const double var_ionic_concentrations__Na_i = 8.0; // millimolar
            const double var_ionic_concentrations__Na_o = 140.0; // millimolar
            const double var_membrane__CmCentre = 2.0000000000000002e-5; // microF
            const double var_membrane__CmPeriphery = 6.4999999999999994e-5; // microF
            const double var_membrane__F = 96845.0; // coulomb_per_mole
            const double var_membrane__R = 8314.0; // millijoule_per_mole_kelvin
            const double var_membrane__T = 310.0; // kelvin
            const double var_L_type_Ca_channel__g_Ca_L = ((var_membrane__Version == 0) ? ((-var_L_type_Ca_channel__g_Ca_L_Centre_Published + var_L_type_Ca_channel__g_Ca_L_Periphery_Published) * var_membrane__FCell + var_L_type_Ca_channel__g_Ca_L_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_L_type_Ca_channel__g_Ca_L_Centre_0DCapable + var_L_type_Ca_channel__g_Ca_L_Periphery_0DCapable) * var_membrane__FCell + var_L_type_Ca_channel__g_Ca_L_Centre_0DCapable) : ((-var_L_type_Ca_channel__g_Ca_L_Centre_1DCapable + var_L_type_Ca_channel__g_Ca_L_Periphery_1DCapable) * var_membrane__FCell + var_L_type_Ca_channel__g_Ca_L_Centre_1DCapable))); // microS
            const double var_L_type_Ca_channel__i_Ca_L = (-var_L_type_Ca_channel__E_Ca_L + var_chaste_interface__membrane__V) * (0.0060000000000000001 / (1.0 + exp(-2.3500000000000001 - 0.16666666666666666 * var_chaste_interface__membrane__V)) + var_chaste_interface__L_type_Ca_channel_d_gate__d_L * var_chaste_interface__L_type_Ca_channel_f_gate__f_L) * var_L_type_Ca_channel__g_Ca_L; // nanoA
            const double var_T_type_Ca_channel__g_Ca_T = ((var_membrane__Version == 0) ? ((-var_T_type_Ca_channel__g_Ca_T_Centre_Published + var_T_type_Ca_channel__g_Ca_T_Periphery_Published) * var_membrane__FCell + var_T_type_Ca_channel__g_Ca_T_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_T_type_Ca_channel__g_Ca_T_Centre_0DCapable + var_T_type_Ca_channel__g_Ca_T_Periphery_0DCapable) * var_membrane__FCell + var_T_type_Ca_channel__g_Ca_T_Centre_0DCapable) : ((-var_T_type_Ca_channel__g_Ca_T_Centre_1DCapable + var_T_type_Ca_channel__g_Ca_T_Periphery_1DCapable) * var_membrane__FCell + var_T_type_Ca_channel__g_Ca_T_Centre_1DCapable))); // microS
            const double var_T_type_Ca_channel__i_Ca_T = (-var_T_type_Ca_channel__E_Ca_T + var_chaste_interface__membrane__V) * var_T_type_Ca_channel__g_Ca_T * var_chaste_interface__T_type_Ca_channel_d_gate__d_T * var_chaste_interface__T_type_Ca_channel_f_gate__f_T; // nanoA
            const double var_calcium_background_current__g_b_Ca = ((var_membrane__Version == 0) ? ((-var_calcium_background_current__g_b_Ca_Centre_Published + var_calcium_background_current__g_b_Ca_Periphery_Published) * var_membrane__FCell + var_calcium_background_current__g_b_Ca_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_calcium_background_current__g_b_Ca_Centre_0DCapable + var_calcium_background_current__g_b_Ca_Periphery_0DCapable) * var_membrane__FCell + var_calcium_background_current__g_b_Ca_Centre_0DCapable) : ((-var_calcium_background_current__g_b_Ca_Centre_1DCapable + var_calcium_background_current__g_b_Ca_Periphery_1DCapable) * var_membrane__FCell + var_calcium_background_current__g_b_Ca_Centre_1DCapable))); // microS
            const double var_four_AP_sensitive_currents__g_sus = ((var_membrane__Version == 0) ? ((-var_four_AP_sensitive_currents__g_sus_Centre_Published + var_four_AP_sensitive_currents__g_sus_Periphery_Published) * var_membrane__FCell + var_four_AP_sensitive_currents__g_sus_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_four_AP_sensitive_currents__g_sus_Centre_0DCapable + var_four_AP_sensitive_currents__g_sus_Periphery_0DCapable) * var_membrane__FCell + var_four_AP_sensitive_currents__g_sus_Centre_0DCapable) : ((-var_four_AP_sensitive_currents__g_sus_Centre_1DCapable + var_four_AP_sensitive_currents__g_sus_Periphery_1DCapable) * var_membrane__FCell + var_four_AP_sensitive_currents__g_sus_Centre_1DCapable))); // microS
            const double var_four_AP_sensitive_currents__g_to = ((var_membrane__Version == 0) ? ((-var_four_AP_sensitive_currents__g_to_Centre_Published + var_four_AP_sensitive_currents__g_to_Periphery_Published) * var_membrane__FCell + var_four_AP_sensitive_currents__g_to_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_four_AP_sensitive_currents__g_to_Centre_0DCapable + var_four_AP_sensitive_currents__g_to_Periphery_0DCapable) * var_membrane__FCell + var_four_AP_sensitive_currents__g_to_Centre_0DCapable) : ((-var_four_AP_sensitive_currents__g_to_Centre_1DCapable + var_four_AP_sensitive_currents__g_to_Periphery_1DCapable) * var_membrane__FCell + var_four_AP_sensitive_currents__g_to_Centre_1DCapable))); // microS
            const double var_hyperpolarisation_activated_current__g_f_K = ((var_membrane__Version == 0) ? ((-var_hyperpolarisation_activated_current__g_f_K_Centre_Published + var_hyperpolarisation_activated_current__g_f_K_Periphery_Published) * var_membrane__FCell + var_hyperpolarisation_activated_current__g_f_K_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_hyperpolarisation_activated_current__g_f_K_Centre_0DCapable + var_hyperpolarisation_activated_current__g_f_K_Periphery_0DCapable) * var_membrane__FCell + var_hyperpolarisation_activated_current__g_f_K_Centre_0DCapable) : ((-var_hyperpolarisation_activated_current__g_f_K_Centre_1DCapable + var_hyperpolarisation_activated_current__g_f_K_Periphery_1DCapable) * var_membrane__FCell + var_hyperpolarisation_activated_current__g_f_K_Centre_1DCapable))); // microS
            const double var_hyperpolarisation_activated_current__g_f_Na = ((var_membrane__Version == 0) ? ((-var_hyperpolarisation_activated_current__g_f_Na_Centre_Published + var_hyperpolarisation_activated_current__g_f_Na_Periphery_Published) * var_membrane__FCell + var_hyperpolarisation_activated_current__g_f_Na_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_hyperpolarisation_activated_current__g_f_Na_Centre_0DCapable + var_hyperpolarisation_activated_current__g_f_Na_Periphery_0DCapable) * var_membrane__FCell + var_hyperpolarisation_activated_current__g_f_Na_Centre_0DCapable) : ((-var_hyperpolarisation_activated_current__g_f_Na_Centre_1DCapable + var_hyperpolarisation_activated_current__g_f_Na_Periphery_1DCapable) * var_membrane__FCell + var_hyperpolarisation_activated_current__g_f_Na_Centre_1DCapable))); // microS
            const double var_membrane__Cm = (-var_membrane__CmCentre + var_membrane__CmPeriphery) * var_membrane__FCell + var_membrane__CmCentre; // microF
            const double var_persistent_calcium_current__i_Ca_p_max_Centre_0DCapable = 0; // nanoA
            const double var_persistent_calcium_current__i_Ca_p_max_Centre_1DCapable = 0.0041999999999999997; // nanoA
            const double var_persistent_calcium_current__i_Ca_p_max_Centre_Published = 0; // nanoA
            const double var_persistent_calcium_current__i_Ca_p_max_Periphery_0DCapable = 0; // nanoA
            const double var_persistent_calcium_current__i_Ca_p_max_Periphery_1DCapable = 0.033390000000000003; // nanoA
            const double var_persistent_calcium_current__i_Ca_p_max_Periphery_Published = 0; // nanoA
            const double var_persistent_calcium_current__i_Ca_p_max = ((var_membrane__Version == 0) ? ((-var_persistent_calcium_current__i_Ca_p_max_Centre_Published + var_persistent_calcium_current__i_Ca_p_max_Periphery_Published) * var_membrane__FCell + var_persistent_calcium_current__i_Ca_p_max_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_persistent_calcium_current__i_Ca_p_max_Centre_0DCapable + var_persistent_calcium_current__i_Ca_p_max_Periphery_0DCapable) * var_membrane__FCell + var_persistent_calcium_current__i_Ca_p_max_Centre_0DCapable) : ((-var_persistent_calcium_current__i_Ca_p_max_Centre_1DCapable + var_persistent_calcium_current__i_Ca_p_max_Periphery_1DCapable) * var_membrane__FCell + var_persistent_calcium_current__i_Ca_p_max_Centre_1DCapable))); // nanoA
            const double var_persistent_calcium_current__i_Ca_p = var_ionic_concentrations__Ca_i * var_persistent_calcium_current__i_Ca_p_max / (0.00040000000000000002 + var_ionic_concentrations__Ca_i); // nanoA
            const double var_potassium_background_current__g_b_K_Centre_0DCapable = 2.5236359999999998e-5; // microS
            const double var_potassium_background_current__g_b_K_Centre_1DCapable = 2.5199999999999999e-5; // microS
            const double var_potassium_background_current__g_b_K_Centre_Published = 2.5199999999999999e-5; // microS
            const double var_potassium_background_current__g_b_K_Periphery_0DCapable = 8.1891999999999995e-5; // microS
            const double var_potassium_background_current__g_b_K_Periphery_1DCapable = 8.1899999999999999e-5; // microS
            const double var_potassium_background_current__g_b_K_Periphery_Published = 8.1899999999999999e-5; // microS
            const double var_potassium_background_current__g_b_K = ((var_membrane__Version == 0) ? ((-var_potassium_background_current__g_b_K_Centre_Published + var_potassium_background_current__g_b_K_Periphery_Published) * var_membrane__FCell + var_potassium_background_current__g_b_K_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_potassium_background_current__g_b_K_Centre_0DCapable + var_potassium_background_current__g_b_K_Periphery_0DCapable) * var_membrane__FCell + var_potassium_background_current__g_b_K_Centre_0DCapable) : ((-var_potassium_background_current__g_b_K_Centre_1DCapable + var_potassium_background_current__g_b_K_Periphery_1DCapable) * var_membrane__FCell + var_potassium_background_current__g_b_K_Centre_1DCapable))); // microS
            const double var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_0DCapable = 0.00079704000000000005; // microS
            const double var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_1DCapable = 0.00073800000000000005; // microS
            const double var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_Published = 0.00079699999999999997; // microS
            const double var_rapid_delayed_rectifying_potassium_current__g_K_r_Periphery_0DCapable = 0.016; // microS
            const double var_rapid_delayed_rectifying_potassium_current__g_K_r_Periphery_1DCapable = 0.020799999999999999; // microS
            const double var_rapid_delayed_rectifying_potassium_current__g_K_r_Periphery_Published = 0.016; // microS
            const double var_rapid_delayed_rectifying_potassium_current__g_K_r = ((var_membrane__Version == 0) ? ((-var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_Published + var_rapid_delayed_rectifying_potassium_current__g_K_r_Periphery_Published) * var_membrane__FCell + var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_0DCapable + var_rapid_delayed_rectifying_potassium_current__g_K_r_Periphery_0DCapable) * var_membrane__FCell + var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_0DCapable) : ((-var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_1DCapable + var_rapid_delayed_rectifying_potassium_current__g_K_r_Periphery_1DCapable) * var_membrane__FCell + var_rapid_delayed_rectifying_potassium_current__g_K_r_Centre_1DCapable))); // microS
            const double var_rapid_delayed_rectifying_potassium_current__P_a = 0.40000000000000002 * var_chaste_interface__rapid_delayed_rectifying_potassium_current_P_as_gate__P_as + 0.59999999999999998 * var_chaste_interface__rapid_delayed_rectifying_potassium_current_P_af_gate__P_af; // dimensionless
            const double var_reversal_and_equilibrium_potentials__E_Ca = 0.5 * var_membrane__R * var_membrane__T * log(var_ionic_concentrations__Ca_o / var_ionic_concentrations__Ca_i) / var_membrane__F; // millivolt
            const double var_calcium_background_current__i_b_Ca = (-var_reversal_and_equilibrium_potentials__E_Ca + var_chaste_interface__membrane__V) * var_calcium_background_current__g_b_Ca; // nanoA
            const double var_reversal_and_equilibrium_potentials__E_K = var_membrane__R * var_membrane__T * log(var_ionic_concentrations__K_o / var_ionic_concentrations__K_i) / var_membrane__F; // millivolt
            const double var_four_AP_sensitive_currents__i_sus = (-var_reversal_and_equilibrium_potentials__E_K + var_chaste_interface__membrane__V) * var_four_AP_sensitive_currents__g_sus * var_chaste_interface__four_AP_sensitive_currents_r_gate__r; // nanoA
            const double var_four_AP_sensitive_currents__i_to = (-var_reversal_and_equilibrium_potentials__E_K + var_chaste_interface__membrane__V) * var_four_AP_sensitive_currents__g_to * var_chaste_interface__four_AP_sensitive_currents_q_gate__q * var_chaste_interface__four_AP_sensitive_currents_r_gate__r; // nanoA
            const double var_hyperpolarisation_activated_current__i_f_K = ((var_membrane__Version != 2.0) ? ((-var_reversal_and_equilibrium_potentials__E_K + var_chaste_interface__membrane__V) * var_hyperpolarisation_activated_current__g_f_K * var_chaste_interface__hyperpolarisation_activated_current_y_gate__y) : ((102.0 + var_chaste_interface__membrane__V) * var_hyperpolarisation_activated_current__g_f_K * var_chaste_interface__hyperpolarisation_activated_current_y_gate__y)); // nanoA
            const double var_potassium_background_current__i_b_K = (-var_reversal_and_equilibrium_potentials__E_K + var_chaste_interface__membrane__V) * var_potassium_background_current__g_b_K; // nanoA
            const double var_rapid_delayed_rectifying_potassium_current__i_K_r = (-var_reversal_and_equilibrium_potentials__E_K + var_chaste_interface__membrane__V) * var_rapid_delayed_rectifying_potassium_current__P_a * var_rapid_delayed_rectifying_potassium_current__g_K_r * var_chaste_interface__rapid_delayed_rectifying_potassium_current_P_i_gate__P_i; // nanoA
            const double var_reversal_and_equilibrium_potentials__E_K_s = ((var_membrane__Version == 0) ? (var_membrane__R * var_membrane__T * log((var_ionic_concentrations__K_o + 0.12 * var_ionic_concentrations__Na_o) / (var_ionic_concentrations__K_i + 0.12 * var_ionic_concentrations__Na_i)) / var_membrane__F) : (var_membrane__R * var_membrane__T * log((var_ionic_concentrations__K_o + 0.029999999999999999 * var_ionic_concentrations__Na_o) / (var_ionic_concentrations__K_i + 0.029999999999999999 * var_ionic_concentrations__Na_i)) / var_membrane__F)); // millivolt
            const double var_reversal_and_equilibrium_potentials__E_Na = var_membrane__R * var_membrane__T * log(var_ionic_concentrations__Na_o / var_ionic_concentrations__Na_i) / var_membrane__F; // millivolt
            const double var_hyperpolarisation_activated_current__i_f_Na = ((var_membrane__Version != 2.0) ? ((-var_reversal_and_equilibrium_potentials__E_Na + var_chaste_interface__membrane__V) * var_hyperpolarisation_activated_current__g_f_Na * var_chaste_interface__hyperpolarisation_activated_current_y_gate__y) : ((-77.599999999999994 + var_chaste_interface__membrane__V) * var_hyperpolarisation_activated_current__g_f_Na * var_chaste_interface__hyperpolarisation_activated_current_y_gate__y)); // nanoA
            const double var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_0DCapable = 0.00034450000000000003; // microS
            const double var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_1DCapable = 0.00034499999999999998; // microS
            const double var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_Published = 0.00051800000000000001; // microS
            const double var_slow_delayed_rectifying_potassium_current__g_K_s_Periphery_0DCapable = 0.0104; // microS
            const double var_slow_delayed_rectifying_potassium_current__g_K_s_Periphery_1DCapable = 0.0104; // microS
            const double var_slow_delayed_rectifying_potassium_current__g_K_s_Periphery_Published = 0.0104; // microS
            const double var_slow_delayed_rectifying_potassium_current__g_K_s = ((var_membrane__Version == 0) ? ((-var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_Published + var_slow_delayed_rectifying_potassium_current__g_K_s_Periphery_Published) * var_membrane__FCell + var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_0DCapable + var_slow_delayed_rectifying_potassium_current__g_K_s_Periphery_0DCapable) * var_membrane__FCell + var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_0DCapable) : ((-var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_1DCapable + var_slow_delayed_rectifying_potassium_current__g_K_s_Periphery_1DCapable) * var_membrane__FCell + var_slow_delayed_rectifying_potassium_current__g_K_s_Centre_1DCapable))); // microS
            const double var_slow_delayed_rectifying_potassium_current__i_K_s = pow(var_chaste_interface__slow_delayed_rectifying_potassium_current_xs_gate__xs, 2) * (-var_reversal_and_equilibrium_potentials__E_K_s + var_chaste_interface__membrane__V) * var_slow_delayed_rectifying_potassium_current__g_K_s; // nanoA
            const double var_sodium_background_current__g_b_Na_Centre_0DCapable = 5.8181799999999999e-5; // microS
            const double var_sodium_background_current__g_b_Na_Centre_1DCapable = 5.8e-5; // microS
            const double var_sodium_background_current__g_b_Na_Centre_Published = 5.8e-5; // microS
            const double var_sodium_background_current__g_b_Na_Periphery_0DCapable = 0.00018880000000000001; // microS
            const double var_sodium_background_current__g_b_Na_Periphery_1DCapable = 0.00018900000000000001; // microS
            const double var_sodium_background_current__g_b_Na_Periphery_Published = 0.00018900000000000001; // microS
            const double var_sodium_background_current__g_b_Na = ((var_membrane__Version == 0) ? ((-var_sodium_background_current__g_b_Na_Centre_Published + var_sodium_background_current__g_b_Na_Periphery_Published) * var_membrane__FCell + var_sodium_background_current__g_b_Na_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_sodium_background_current__g_b_Na_Centre_0DCapable + var_sodium_background_current__g_b_Na_Periphery_0DCapable) * var_membrane__FCell + var_sodium_background_current__g_b_Na_Centre_0DCapable) : ((-var_sodium_background_current__g_b_Na_Centre_1DCapable + var_sodium_background_current__g_b_Na_Periphery_1DCapable) * var_membrane__FCell + var_sodium_background_current__g_b_Na_Centre_1DCapable))); // microS
            const double var_sodium_background_current__i_b_Na = (-var_reversal_and_equilibrium_potentials__E_Na + var_chaste_interface__membrane__V) * var_sodium_background_current__g_b_Na; // nanoA
            const double var_sodium_calcium_exchanger__d_NaCa = 0.0001; // dimensionless
            const double var_sodium_calcium_exchanger__gamma_NaCa = 0.5; // dimensionless
            const double var_sodium_calcium_exchanger__k_NaCa_Centre_0DCapable = 2.7228999999999998e-6; // nanoA
            const double var_sodium_calcium_exchanger__k_NaCa_Centre_1DCapable = 2.7999999999999999e-6; // nanoA
            const double var_sodium_calcium_exchanger__k_NaCa_Centre_Published = 2.7e-6; // nanoA
            const double var_sodium_calcium_exchanger__k_NaCa_Periphery_0DCapable = 8.8358400000000004e-6; // nanoA
            const double var_sodium_calcium_exchanger__k_NaCa_Periphery_1DCapable = 8.8000000000000004e-6; // nanoA
            const double var_sodium_calcium_exchanger__k_NaCa_Periphery_Published = 8.8000000000000004e-6; // nanoA
            const double var_sodium_calcium_exchanger__k_NaCa = ((var_membrane__Version == 0) ? ((-var_sodium_calcium_exchanger__k_NaCa_Centre_Published + var_sodium_calcium_exchanger__k_NaCa_Periphery_Published) * var_membrane__FCell + var_sodium_calcium_exchanger__k_NaCa_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_sodium_calcium_exchanger__k_NaCa_Centre_0DCapable + var_sodium_calcium_exchanger__k_NaCa_Periphery_0DCapable) * var_membrane__FCell + var_sodium_calcium_exchanger__k_NaCa_Centre_0DCapable) : ((-var_sodium_calcium_exchanger__k_NaCa_Centre_1DCapable + var_sodium_calcium_exchanger__k_NaCa_Periphery_1DCapable) * var_membrane__FCell + var_sodium_calcium_exchanger__k_NaCa_Centre_1DCapable))); // nanoA
            const double var_sodium_calcium_exchanger__i_NaCa = ((var_membrane__Version == 0) ? ((pow(var_ionic_concentrations__Na_i, 3) * var_ionic_concentrations__Ca_o * exp(0.037429999999999998 * var_chaste_interface__membrane__V * var_sodium_calcium_exchanger__gamma_NaCa) - pow(var_ionic_concentrations__Na_o, 3) * var_ionic_concentrations__Ca_i * exp(0.037400000000000003 * (-1.0 + var_sodium_calcium_exchanger__gamma_NaCa) * var_chaste_interface__membrane__V)) * var_sodium_calcium_exchanger__k_NaCa / (1.0 + (pow(var_ionic_concentrations__Na_i, 3) * var_ionic_concentrations__Ca_o + pow(var_ionic_concentrations__Na_o, 3) * var_ionic_concentrations__Ca_i) * var_sodium_calcium_exchanger__d_NaCa)) : ((pow(var_ionic_concentrations__Na_i, 3) * var_ionic_concentrations__Ca_o * exp(0.037429999999999998 * var_chaste_interface__membrane__V * var_sodium_calcium_exchanger__gamma_NaCa) - pow(var_ionic_concentrations__Na_o, 3) * var_ionic_concentrations__Ca_i * exp(0.037429999999999998 * (-1.0 + var_sodium_calcium_exchanger__gamma_NaCa) * var_chaste_interface__membrane__V)) * var_sodium_calcium_exchanger__k_NaCa / (1.0 + (pow(var_ionic_concentrations__Na_i, 3) * var_ionic_concentrations__Ca_o + pow(var_ionic_concentrations__Na_o, 3) * var_ionic_concentrations__Ca_i) * var_sodium_calcium_exchanger__d_NaCa))); // nanoA
            const double var_sodium_current__g_Na_Centre_0DCapable = 0; // microlitre_per_second
            const double var_sodium_current__g_Na_Centre_1DCapable = 0; // microlitre_per_second
            const double var_sodium_current__g_Na_Centre_Published = 0; // microlitre_per_second
            const double var_sodium_current__g_Na_Periphery_0DCapable = 1.204e-6; // microlitre_per_second
            const double var_sodium_current__g_Na_Periphery_1DCapable = 3.7e-7; // microlitre_per_second
            const double var_sodium_current__g_Na_Periphery_Published = 1.1999999999999999e-6; // microlitre_per_second
            const double var_sodium_current__g_Na = ((var_membrane__Version == 0) ? ((-var_sodium_current__g_Na_Centre_Published + var_sodium_current__g_Na_Periphery_Published) * var_membrane__FCell + var_sodium_current__g_Na_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_sodium_current__g_Na_Centre_0DCapable + var_sodium_current__g_Na_Periphery_0DCapable) * var_membrane__FCell + var_sodium_current__g_Na_Centre_0DCapable) : ((-var_sodium_current__g_Na_Centre_1DCapable + var_sodium_current__g_Na_Periphery_1DCapable) * var_membrane__FCell + var_sodium_current__g_Na_Centre_1DCapable))); // microlitre_per_second
            const double var_sodium_current_h_gate__F_Na = ((var_membrane__Version == 0) ? (0.086900000000000005 + 0.095200000000000007 * exp(-2.1671999999999998 - 0.063 * var_chaste_interface__membrane__V) / (1.0 + 1.6599999999999999 * exp(-14.332500000000001 - 0.22500000000000001 * var_chaste_interface__membrane__V))) : (0.086929999999999993 + 0.095180000000000001 * exp(-2.1692640000000001 - 0.063060000000000005 * var_chaste_interface__membrane__V) / (1.0 + 1.6619999999999999 * exp(-14.33887 - 0.22509999999999999 * var_chaste_interface__membrane__V)))); // dimensionless
            const double var_sodium_current_h_gate__h = (1.0 - var_sodium_current_h_gate__F_Na) * var_chaste_interface__sodium_current_h_gate__h1 + var_sodium_current_h_gate__F_Na * var_chaste_interface__sodium_current_h_gate__h2; // dimensionless
            const double var_sodium_current__i_Na = pow(var_membrane__F, 2) * pow(var_chaste_interface__sodium_current_m_gate__m, 3) * (-1.0 + exp((-var_reversal_and_equilibrium_potentials__E_Na + var_chaste_interface__membrane__V) * var_membrane__F / (var_membrane__R * var_membrane__T))) * var_ionic_concentrations__Na_o * var_chaste_interface__membrane__V * var_sodium_current__g_Na * var_sodium_current_h_gate__h / ((-1.0 + exp(var_membrane__F * var_chaste_interface__membrane__V / (var_membrane__R * var_membrane__T))) * var_membrane__R * var_membrane__T); // nanoA
            const double var_sodium_potassium_pump__K_m_K = 0.621; // millimolar
            const double var_sodium_potassium_pump__K_m_Na = 5.6399999999999997; // millimolar
            const double var_sodium_potassium_pump__i_p_max_Centre_0DCapable = 0.047825449999999999; // nanoA
            const double var_sodium_potassium_pump__i_p_max_Centre_1DCapable = 0.047800000000000002; // nanoA
            const double var_sodium_potassium_pump__i_p_max_Centre_Published = 0.047800000000000002; // nanoA
            const double var_sodium_potassium_pump__i_p_max_Periphery_0DCapable = 0.15519359999999999; // nanoA
            const double var_sodium_potassium_pump__i_p_max_Periphery_1DCapable = 0.16; // nanoA
            const double var_sodium_potassium_pump__i_p_max_Periphery_Published = 0.16; // nanoA
            const double var_sodium_potassium_pump__i_p_max = ((var_membrane__Version == 0) ? ((-var_sodium_potassium_pump__i_p_max_Centre_Published + var_sodium_potassium_pump__i_p_max_Periphery_Published) * var_membrane__FCell + var_sodium_potassium_pump__i_p_max_Centre_Published) : ((var_membrane__Version == 1.0) ? ((-var_sodium_potassium_pump__i_p_max_Centre_0DCapable + var_sodium_potassium_pump__i_p_max_Periphery_0DCapable) * var_membrane__FCell + var_sodium_potassium_pump__i_p_max_Centre_0DCapable) : ((-var_sodium_potassium_pump__i_p_max_Centre_1DCapable + var_sodium_potassium_pump__i_p_max_Periphery_1DCapable) * var_membrane__FCell + var_sodium_potassium_pump__i_p_max_Centre_1DCapable))); // nanoA
            const double var_sodium_potassium_pump__i_p = 1.6000000000000001 * pow(var_ionic_concentrations__K_o, 2) * pow(var_ionic_concentrations__Na_i, 3) * var_sodium_potassium_pump__i_p_max / ((1.5 + exp(-1.5 - 0.025000000000000001 * var_chaste_interface__membrane__V)) * pow((var_ionic_concentrations__K_o + var_sodium_potassium_pump__K_m_K), 2) * pow((var_ionic_concentrations__Na_i + var_sodium_potassium_pump__K_m_Na), 3)); // nanoA
            const double var_membrane__V_orig_deriv = -1.0 * (var_L_type_Ca_channel__i_Ca_L + var_T_type_Ca_channel__i_Ca_T + var_calcium_background_current__i_b_Ca + var_four_AP_sensitive_currents__i_sus + var_four_AP_sensitive_currents__i_to + var_hyperpolarisation_activated_current__i_f_K + var_hyperpolarisation_activated_current__i_f_Na + var_persistent_calcium_current__i_Ca_p + var_potassium_background_current__i_b_K + var_rapid_delayed_rectifying_potassium_current__i_K_r + var_slow_delayed_rectifying_potassium_current__i_K_s + var_sodium_background_current__i_b_Na + var_sodium_calcium_exchanger__i_NaCa + var_sodium_current__i_Na + var_sodium_potassium_pump__i_p) / var_membrane__Cm; // millivolt / second
            d_dt_chaste_interface_var_membrane__V = 0.001 * var_membrane__V_orig_deriv; // millivolt / millisecond
        }
        
        rDY[0] = d_dt_chaste_interface_var_membrane__V;
        rAlphaOrTau[1] = 1000.0 * var_sodium_current_m_gate__tau_m;
        rBetaOrInf[1] = var_sodium_current_m_gate__m_infinity;
        rAlphaOrTau[2] = 1000.0 * var_sodium_current_h_gate__tau_h1;
        rBetaOrInf[2] = var_sodium_current_h_gate__h1_infinity;
        rAlphaOrTau[3] = 1000.0 * var_sodium_current_h_gate__tau_h2;
        rBetaOrInf[3] = var_sodium_current_h_gate__h2_infinity;
        rAlphaOrTau[4] = 1000.0 * var_L_type_Ca_channel_d_gate__tau_d_L;
        rBetaOrInf[4] = var_L_type_Ca_channel_d_gate__d_L_infinity;
        rAlphaOrTau[5] = 1000.0 * var_L_type_Ca_channel_f_gate__tau_f_L;
        rBetaOrInf[5] = var_L_type_Ca_channel_f_gate__f_L_infinity;
        rAlphaOrTau[6] = 1000.0 * var_T_type_Ca_channel_d_gate__tau_d_T;
        rBetaOrInf[6] = var_T_type_Ca_channel_d_gate__d_T_infinity;
        rAlphaOrTau[7] = 1000.0 * var_T_type_Ca_channel_f_gate__tau_f_T;
        rBetaOrInf[7] = var_T_type_Ca_channel_f_gate__f_T_infinity;
        rAlphaOrTau[8] = 1000.0 * var_four_AP_sensitive_currents_q_gate__tau_q;
        rBetaOrInf[8] = var_four_AP_sensitive_currents_q_gate__q_infinity;
        rAlphaOrTau[9] = 1000.0 * var_four_AP_sensitive_currents_r_gate__tau_r;
        rBetaOrInf[9] = var_four_AP_sensitive_currents_r_gate__r_infinity;
        rAlphaOrTau[10] = 1000.0 * var_rapid_delayed_rectifying_potassium_current_P_af_gate__tau_P_af;
        rBetaOrInf[10] = var_rapid_delayed_rectifying_potassium_current_P_af_gate__P_af_infinity;
        rAlphaOrTau[11] = 1000.0 * var_rapid_delayed_rectifying_potassium_current_P_as_gate__tau_P_as;
        rBetaOrInf[11] = var_rapid_delayed_rectifying_potassium_current_P_as_gate__P_as_infinity;
        rAlphaOrTau[12] = 1000.0 * var_rapid_delayed_rectifying_potassium_current_P_i_gate__tau_P_i;
        rBetaOrInf[12] = var_rapid_delayed_rectifying_potassium_current_P_i_gate__P_i_infinity;
        rAlphaOrTau[13] = 0.001 * var_slow_delayed_rectifying_potassium_current_xs_gate__alpha_xs;
        rBetaOrInf[13] = 0.001 * var_slow_delayed_rectifying_potassium_current_xs_gate__beta_xs;
        rAlphaOrTau[14] = 0.001 * var_hyperpolarisation_activated_current_y_gate__alpha_y;
        rBetaOrInf[14] = 0.001 * var_hyperpolarisation_activated_current_y_gate__beta_y;
    }
    void Cellzhang_SAN_model_2000_allFromCellMLRushLarsen::ComputeOneStepExceptVoltage(const std::vector<double> &rDY, const std::vector<double> &rAlphaOrTau, const std::vector<double> &rBetaOrInf)
    {
        std::vector<double>& rY = rGetStateVariables();
        
        rY[1] = rBetaOrInf[1] + (rY[1] - rBetaOrInf[1])*exp(-mDt/rAlphaOrTau[1]);
        rY[2] = rBetaOrInf[2] + (rY[2] - rBetaOrInf[2])*exp(-mDt/rAlphaOrTau[2]);
        rY[3] = rBetaOrInf[3] + (rY[3] - rBetaOrInf[3])*exp(-mDt/rAlphaOrTau[3]);
        rY[4] = rBetaOrInf[4] + (rY[4] - rBetaOrInf[4])*exp(-mDt/rAlphaOrTau[4]);
        rY[5] = rBetaOrInf[5] + (rY[5] - rBetaOrInf[5])*exp(-mDt/rAlphaOrTau[5]);
        rY[6] = rBetaOrInf[6] + (rY[6] - rBetaOrInf[6])*exp(-mDt/rAlphaOrTau[6]);
        rY[7] = rBetaOrInf[7] + (rY[7] - rBetaOrInf[7])*exp(-mDt/rAlphaOrTau[7]);
        rY[8] = rBetaOrInf[8] + (rY[8] - rBetaOrInf[8])*exp(-mDt/rAlphaOrTau[8]);
        rY[9] = rBetaOrInf[9] + (rY[9] - rBetaOrInf[9])*exp(-mDt/rAlphaOrTau[9]);
        rY[10] = rBetaOrInf[10] + (rY[10] - rBetaOrInf[10])*exp(-mDt/rAlphaOrTau[10]);
        rY[11] = rBetaOrInf[11] + (rY[11] - rBetaOrInf[11])*exp(-mDt/rAlphaOrTau[11]);
        rY[12] = rBetaOrInf[12] + (rY[12] - rBetaOrInf[12])*exp(-mDt/rAlphaOrTau[12]);
        {
            const double tau_inv = rAlphaOrTau[13] + rBetaOrInf[13];
            const double y_inf = rAlphaOrTau[13] / tau_inv;
            rY[13] = y_inf + (rY[13] - y_inf)*exp(-mDt*tau_inv);
        }
        {
            const double tau_inv = rAlphaOrTau[14] + rBetaOrInf[14];
            const double y_inf = rAlphaOrTau[14] / tau_inv;
            rY[14] = y_inf + (rY[14] - y_inf)*exp(-mDt*tau_inv);
        }
    }

    std::vector<double> Cellzhang_SAN_model_2000_allFromCellMLRushLarsen::ComputeDerivedQuantities(double var_chaste_interface__environment__time_converted, const std::vector<double> & rY)
    {
        // Inputs:
        // Time units: millisecond
        

        // Mathematics

        std::vector<double> dqs(1);
        dqs[0] = var_chaste_interface__environment__time_converted;
        return dqs;
    }

template<>
void OdeSystemInformation<Cellzhang_SAN_model_2000_allFromCellMLRushLarsen>::Initialise(void)
{
    this->mSystemName = "zhang_SAN_model_2000_all";
    this->mFreeVariableName = "environment__time";
    this->mFreeVariableUnits = "millisecond";

    // rY[0]:
    this->mVariableNames.push_back("membrane_voltage");
    this->mVariableUnits.push_back("millivolt");
    this->mInitialConditions.push_back(-39.013558536);

    // rY[1]:
    this->mVariableNames.push_back("sodium_current_m_gate__m");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.092361701692);

    // rY[2]:
    this->mVariableNames.push_back("sodium_current_h_gate__h1");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.015905380261);

    // rY[3]:
    this->mVariableNames.push_back("sodium_current_h_gate__h2");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.01445216109);

    // rY[4]:
    this->mVariableNames.push_back("L_type_Ca_channel_d_gate__d_L");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.04804900895);

    // rY[5]:
    this->mVariableNames.push_back("L_type_Ca_channel_f_gate__f_L");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.48779845203);

    // rY[6]:
    this->mVariableNames.push_back("T_type_Ca_channel_d_gate__d_T");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.42074047435);

    // rY[7]:
    this->mVariableNames.push_back("T_type_Ca_channel_f_gate__f_T");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.038968420558);

    // rY[8]:
    this->mVariableNames.push_back("four_AP_sensitive_currents_q_gate__q");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.29760539675);

    // rY[9]:
    this->mVariableNames.push_back("four_AP_sensitive_currents_r_gate__r");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.064402950262);

    // rY[10]:
    this->mVariableNames.push_back("rapid_delayed_rectifying_potassium_current_P_af_gate__P_af");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.13034201158);

    // rY[11]:
    this->mVariableNames.push_back("rapid_delayed_rectifying_potassium_current_P_as_gate__P_as");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.46960956028);

    // rY[12]:
    this->mVariableNames.push_back("rapid_delayed_rectifying_potassium_current_P_i_gate__P_i");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.87993375273);

    // rY[13]:
    this->mVariableNames.push_back("slow_delayed_rectifying_potassium_current_xs_gate__xs");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.082293827208);

    // rY[14]:
    this->mVariableNames.push_back("hyperpolarisation_activated_current_y_gate__y");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.03889291759);

    // Derived Quantity index [0]:
    this->mDerivedQuantityNames.push_back("environment__time");
    this->mDerivedQuantityUnits.push_back("millisecond");

    this->mInitialised = true;
}

// Serialization for Boost >= 1.36
#include "SerializationExportWrapperForCpp.hpp"
CHASTE_CLASS_EXPORT(Cellzhang_SAN_model_2000_allFromCellMLRushLarsen)
